## coin3 4.0.2%2Bds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

set(COIN_MAJOR_VERSION 4)
set(COIN_MINOR_VERSION 0)
set(COIN_MICRO_VERSION 2)
set(COIN_BETA_VERSION)
set(COIN_VERSION ${COIN_MAJOR_VERSION}.${COIN_MINOR_VERSION}.${COIN_MICRO_VERSION}${COIN_BETA_VERSION})

project(Coin VERSION ${COIN_MAJOR_VERSION}.${COIN_MINOR_VERSION}.${COIN_MICRO_VERSION})
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

string(TIMESTAMP COIN_BUILD_YEAR "%Y")
math(EXPR COIN_SO_VERSION ${PROJECT_VERSION_MAJOR}*20)

# ############################################################################
# these will be removed after upgrading CMake minimum version
set(PROJECT_DESCRIPTION "A high-level 3D visualization library with Open Inventor 2.1 API")
# ############################################################################

if(POLICY CMP0054)
  # CMake version 3.14.5 warns when the policy is not set and uses OLD behaviour
  cmake_policy(SET CMP0054 NEW)
endif()

if(POLICY CMP0072)
  # get rid of OpenGL GLVND warning from CMake 3.11
  cmake_policy(SET CMP0072 NEW)
endif()

if(POLICY CMP0075)
  # get rid of CMAKE_REQUIRED_LIBRARIES warning from CMake 3.12.2
  cmake_policy(SET CMP0075 NEW)
endif()

# ############################################################################
# Prevent in-source builds, as they often cause severe build problems
# ############################################################################

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "${CMAKE_PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake <path_to_${CMAKE_PROJECT_NAME}> [options]' from there.")
endif()

# ############################################################################
# Include necessary submodules
# ############################################################################

# Add path for Coin specific utility scripts
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

include(CheckCSourceRuns)
include(CheckCXXSourceCompiles)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(CheckTypeSize)
include(CMakeDependentOption)
include(GNUInstallDirs)
include(FeatureSummary)
include(CoinCMakeUtilities)

# ############################################################################
# Provide options to customise the build
# ############################################################################

option(COIN_BUILD_SHARED_LIBS "Build shared library when ON (default), static when OFF." ON)
option(COIN_BUILD_TESTS "Build unit tests when ON (default), skips them when OFF." ON)
option(COIN_BUILD_DOCUMENTATION "Build and install API documentation (requires Doxygen)." OFF)
cmake_dependent_option(COIN_BUILD_INTERNAL_DOCUMENTATION "Document internal code not part of the API." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_MAN "Build Coin man pages." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_QTHELP "Build QtHelp documentation." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_CHM "Build compressed HTML help manual (requires HTML help compiler)" OFF "COIN_BUILD_DOCUMENTATION" OFF)

option(COIN_THREADSAFE "Enable thread safe render traversals." OFF)
option(HAVE_VRML97 "Enable VRML97 support." ON)
cmake_dependent_option(COIN_HAVE_JAVASCRIPT "Enable JavaScript capabilities for VRML97." ON "HAVE_VRML97" OFF)
option(HAVE_NODEKITS "Enable NodeKit support." ON)
cmake_dependent_option(HAVE_DRAGGERS "Enable Dragger support." ON "HAVE_NODEKITS" OFF)
cmake_dependent_option(HAVE_MANIPULATORS "Enable Manipulator support." ON "HAVE_NODEKITS" OFF)
option(HAVE_SOUND "Enable OpenAL sound support." ON)
option(HAVE_3DS_IMPORT_CAPABILITIES "Enable 3ds import capabilities." ON)
option(USE_EXTERNAL_EXPAT "Use system install of Expat." OFF)
option(USE_EXCEPTIONS "Compile with exceptions (g++ only)." ON)
option(USE_SUPERGLU "Use superglu library when ON, GLU implementation of platform when OFF (default)." OFF)

option(FONTCONFIG_RUNTIME_LINKING   "Enable FontConfig runtime linking when ON (default), disable when OFF." ON)
option(FREETYPE_RUNTIME_LINKING     "Enable FreeType runtime linking when ON (default), disable when OFF." ON)
option(LIBBZIP2_RUNTIME_LINKING     "Enable libBZip2 runtime linking when ON (default), disable when OFF." ON)
option(OPENAL_RUNTIME_LINKING       "Enable OpenAL runtime linking when ON (default), disable when OFF." ON)
option(SIMAGE_RUNTIME_LINKING       "Enable simage runtime linking when ON (default), disable when OFF" ON)
option(ZLIB_RUNTIME_LINKING         "Enable ZLib runtime linking when ON (default), disable when OFF." ON)
option(GLU_RUNTIME_LINKING          "Enable GLU runtime linking when ON (default), disable when OFF." ON)
option(SPIDERMONKEY_RUNTIME_LINKING "Enable SpiderMonkey runtime linking when ON (default), disable when OFF." ON)

option(COIN_VERBOSE "Add verbose debugging information during the configure process." OFF)
option(HAVE_MULTIPLE_VERSION "Forces versioned paths for includes and documentation when ON, usual behaviour otherwise." OFF)
option(COIN_USE_CPACK "If enabled the cpack subrepo is mandatory" OFF)

cmake_dependent_option(COIN_BUILD_MAC_FRAMEWORK "Build framework instead of dylib on Mac OS X when ON. Only valid if COIN_BUILD_SHARED_LIBS is ON." OFF "APPLE;NOT IOS;COIN_BUILD_SHARED_LIBS" OFF)
cmake_dependent_option(COIN_BUILD_MAC_X11 "Build for X11 on Mac OS X when ON. Default is OFF." OFF "APPLE" OFF)
cmake_dependent_option(COIN_BUILD_MAC_AGL "Build for AGL on Mac OS X when ON. Default is OFF." OFF "APPLE" OFF)

check_include_file_cxx(thread HAVE_STD_THREAD)
cmake_dependent_option(COIN_DEBUG_CHECK_THREAD "Enable thread check in several central Coin functions." OFF "HAVE_STD_THREAD" OFF)

report_prepare(
  COIN_BUILD_SHARED_LIBS
  COIN_BUILD_TESTS
  COIN_BUILD_DOCUMENTATION
  COIN_BUILD_INTERNAL_DOCUMENTATION
  COIN_BUILD_DOCUMENTATION_MAN
  COIN_BUILD_DOCUMENTATION_QTHELP
  COIN_BUILD_DOCUMENTATION_CHM
  COIN_THREADSAFE
  HAVE_VRML97
  COIN_HAVE_JAVASCRIPT
  HAVE_NODEKITS
  HAVE_DRAGGERS
  HAVE_MANIPULATORS
  HAVE_SOUND
  HAVE_3DS_IMPORT_CAPABILITIES
  USE_EXTERNAL_EXPAT
  USE_EXCEPTIONS
  USE_SUPERGLU
  FONTCONFIG_RUNTIME_LINKING
  FREETYPE_RUNTIME_LINKING
  LIBBZIP2_RUNTIME_LINKING
  OPENAL_RUNTIME_LINKING
  SIMAGE_RUNTIME_LINKING
  ZLIB_RUNTIME_LINKING
  GLU_RUNTIME_LINKING
  SPIDERMONKEY_RUNTIME_LINKING
  HAVE_MULTIPLE_VERSION
  IF_APPLE
    COIN_BUILD_MAC_FRAMEWORK
    COIN_BUILD_MAC_X11
    COIN_BUILD_MAC_AGL
  IF_MSVC
    COIN_BUILD_MSVC_STATIC_RUNTIME
    COIN_BUILD_SINGLE_LIB
    MSVC_VERSION
    COIN_BUILD_MSVC_MP
)

if(HAVE_MULTIPLE_VERSION)
  # Modifies the installation path for distributed includes, docs and datadir
  versionize(INCLUDEDIR DOCDIR DATADIR)
  dump_variable(
    CMAKE_INSTALL_DATADIR
    CMAKE_INSTALL_FULL_DATADIR
    CMAKE_INSTALL_INCLUDEDIR
    CMAKE_INSTALL_FULL_INCLUDEDIR
    CMAKE_INSTALL_DOCDIR
    CMAKE_INSTALL_FULL_DOCDIR
  )
else()
  set(CMAKE_INSTALL_DATADIR "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}")
endif()

# ############################################################################
# Find all necessary and optional Coin3D dependencies
# ############################################################################

# Fail early if one of the required packages cannot be found

# As not all CMake FindXXX modules and config packages provide target support,
# we should explicitly check for them on.
find_package(Boost REQUIRED) # almost any Boost will do
# Boost::boost - Target for header only dependencies (Boost include directory)
if(NOT TARGET Boost::boost)
  list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES ${Boost_INCLUDE_DIRS})
else()
  list(APPEND COIN_TARGET_LINK_LIBRARIES Boost::boost)
endif()

if(COIN_BUILD_MAC_X11)
  find_package(X11 REQUIRED)
  # On Mac OS X, GLX is provided as a separate OpenGL implementation, different
  # from the standard OpenGL framework which provides support for GLUT and native
  # Mac OS X applications.
  if(X11_FOUND)
    find_path(X11_GL_INCLUDE_PATH GL/glx.h ${X11_INC_SEARCH_PATH})
    if(NOT X11_GL_INCLUDE_PATH)
      message(FATAL_ERROR "Could not find GL/glx.h")
    endif()

    find_library(X11_GL_LIB GL ${X11_LIB_SEARCH_PATH})
    if(NOT X11_GL_LIB)
      message(FATAL_ERROR "Could not find libGL.dylib")
    endif()

    find_library(X11_GLU_LIB GLU ${X11_LIB_SEARCH_PATH})
    if(NOT X11_GLU_LIB)
      message(FATAL_ERROR "Could not find libGLU.dylib")
    endif()
    list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES ${X11_INCLUDE_DIR} ${X11_GL_INCLUDE_PATH})
    list(APPEND COIN_TARGET_LINK_LIBRARIES ${X11_LIBRARIES} ${X11_GL_LIB} ${X11_GLU_LIB})
  endif()
else()
  if(UNIX AND NOT APPLE)
    find_package(X11 REQUIRED)
    list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES ${X11_INCLUDE_DIR})
    list(APPEND COIN_TARGET_LINK_LIBRARIES ${X11_LIBRARIES})
  endif()
  find_package(OpenGL REQUIRED)
  if(OPENGL_FOUND)
    set(HAVE_OPENGL 1)
    set(OPENGL_SYSTEM_LIBRARY_NAME "${OPENGL_gl_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    if(OpenGL_GLU_FOUND)
      set(HAVE_GLU 1)
    endif()
    if(APPLE)
      set(GLU_IS_PART_OF_GL 1)
    endif()
    #include_directories("${OPENGL_INCLUDE_DIR}")
    if (NOT TARGET OpenGL::GL)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES ${OPENGL_INCLUDE_DIR})
      list(APPEND COIN_TARGET_LINK_LIBRARIES ${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY})
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES OpenGL::GL OpenGL::GLU)
    endif()
  endif()
endif()

set(CMAKE_THREAD_PREFER_PTHREAD 1)
set(THREADS_PREFER_PTHREAD_FLAG 1)
find_package(Threads)
if(Threads_FOUND)
  set(HAVE_THREADS 1)
  if(CMAKE_USE_WIN32_THREADS_INIT)
    set(USE_W32THREAD 1)
    set(COIN_THREADID_TYPE DWORD)
  elseif(CMAKE_USE_PTHREADS_INIT)
    set(USE_PTHREAD 1)
    set(COIN_THREADID_TYPE pthread_t)
  endif()
  list(APPEND COIN_TARGET_LINK_LIBRARIES Threads::Threads)
  #pthreads does not provide pkg-config file, therefore not added here
endif()

if(USE_EXTERNAL_EXPAT)
  find_package(EXPAT)
  if(EXPAT_FOUND)
    set(HAVE_EXPAT 1)
    if(NOT TARGET EXPAT::EXPAT)
      add_library(EXPAT::EXPAT UNKNOWN IMPORTED)
      set_target_properties(EXPAT::EXPAT PROPERTIES
        IMPORTED_LINK_INTERFACE_LANGUAGES "C"
        IMPORTED_LOCATION "${EXPAT_LIBRARIES}"
        INTERFACE_INCLUDE_DIRECTORIES "${EXPAT_INCLUDE_DIRS}")
    endif()
    list(APPEND COIN_TARGET_LINK_LIBRARIES EXPAT::EXPAT)
  endif()
else()
  if(NOT WIN32)
    set(XML_DEV_URANDOM 1)
  endif()
endif()

if(USE_SUPERGLU)
  find_package(superglu)
  if(superglu_FOUND)
    set(HAVE_SUPERGLU 1)
    set(GLU_RUNTIME_LINKING OFF)
    list(REMOVE_ITEM COIN_TARGET_LINK_LIBRARIES ${OPENGL_glu_LIBRARY})
    if(TARGET OpenGL::GLU)
      list(REMOVE_ITEM COIN_TARGET_LINK_LIBRARIES OpenGL::GLU)
    endif()
    list(APPEND COIN_TARGET_LINK_LIBRARIES superglu::GLU)
  endif()
endif()

#find_package(FLEX)
#if(FLEX_FOUND)
# set(HAVE_FLEX 1)
# #include_directories(${FLEX_INCLUDE_DIRS})
# #list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES ${FLEX_INCLUDE_DIRS})
#endif()
#
#find_package(BISON)
#if(BISON_FOUND)
# set(HAVE_BISON 1)
# #include_directories(${BISON_INCLUDE_DIRS})
# #list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES ${BISON_INCLUDE_DIRS})
#endif()

if(HAVE_SOUND)
  if(NOT OPENAL_RUNTIME_LINKING)
    find_package(OpenAL)
    if(OpenAL_FOUND)
      set(HAVE_OPENAL 1)
      # Checks specific OpenAL configurations
      set(CMAKE_REQUIRED_INCLUDES ${OPENGL_INCLUDE_DIR})
      check_include_file(AL/al.h HAVE_AL_AL_H)
      check_include_file(OpenAL/al.h HAVE_OPENAL_AL_H)
      set(CMAKE_REQUIRED_INCLUDES)
      if(NOT TARGET OpenAL::OpenAL)
        add_library(OpenAL::OpenAL UNKNOWN IMPORTED)
        set_target_properties(OpenAL::OpenAL PROPERTIES
          IMPORTED_LINK_INTERFACE_LANGUAGES "C"
          IMPORTED_LOCATION "${OPENAL_LIBRARY}"

## coin3 4.0.2+ds

=== examples/dynloadextensions/CMakeLists.txt ===
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions(-DCOIN_DEBUG=1)
else()
  add_definitions(-DCOIN_DEBUG=0)
endif()

include_directories(BEFORE ${PROJECT_SOURCE_DIR}/include)

add_library(Switchboard SHARED Switchboard.cpp)
target_compile_definitions(Switchboard PRIVATE "-DSWITCHBOARD_INTERNAL")

add_library(SwitchboardOperator SHARED SwitchboardOperator.cpp)
target_compile_definitions(SwitchboardOperator PRIVATE "-DSWITCHBOARDOPERATOR_INTERNAL")
target_link_libraries(SwitchboardOperator Switchboard)

=== src/base/CMakeLists.txt ===
# source files
set(COIN_BASE_FILES
	dict.cpp
	hash.cpp
	heap.cpp
	list.cpp
	memalloc.cpp
	rbptree.cpp
	time.cpp
	string.cpp
	dynarray.cpp
	namemap.cpp
	SbBSPTree.cpp
	SbByteBuffer.cpp
	SbBox2s.cpp
	SbBox2i32.cpp
	SbBox2f.cpp
	SbBox2d.cpp
	SbBox3s.cpp
	SbBox3i32.cpp
	SbBox3f.cpp
	SbBox3d.cpp
	SbClip.cpp
	SbColor.cpp
	SbColor4f.cpp
	SbCylinder.cpp
	SbDict.cpp
	SbDPLine.cpp
	SbDPMatrix.cpp
	SbDPPlane.cpp
	SbDPRotation.cpp
	SbHeap.cpp
	SbImage.cpp
	SbLine.cpp
	SbMatrix.cpp
	SbName.cpp
	SbOctTree.cpp
	SbPlane.cpp
	SbRotation.cpp
	SbSphere.cpp
	SbString.cpp
	SbTesselator.cpp
	SbGLUTessellator.cpp
	SbTime.cpp
	SbVec2b.cpp
	SbVec2ub.cpp
	SbVec2s.cpp
	SbVec2us.cpp
	SbVec2i32.cpp
	SbVec2ui32.cpp
	SbVec2f.cpp
	SbVec2d.cpp
	SbVec3b.cpp
	SbVec3ub.cpp
	SbVec3s.cpp
	SbVec3us.cpp
	SbVec3i32.cpp
	SbVec3ui32.cpp
	SbVec3f.cpp
	SbVec3d.cpp
	SbVec4b.cpp
	SbVec4ub.cpp
	SbVec4s.cpp
	SbVec4us.cpp
	SbVec4i32.cpp
	SbVec4ui32.cpp
	SbVec4f.cpp
	SbVec4d.cpp
	SbViewVolume.cpp
	SbDPViewVolume.cpp
	SbViewportRegion.cpp
	SbXfBox3f.cpp
	SbXfBox3d.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_BASE_INTERNAL_FILES
	coinString.h
	dict.h
	dict.cpp
	dictp.h
	dynarray.h
	dynarray.cpp
	hashp.h
	heapp.h
	namemap.h
	namemap.cpp
	SbGLUTessellator.h
	SbGLUTessellator.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_BASE_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} base/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(base OBJECT ${COIN_BASE_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_BASE_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/base/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_BASE_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/base/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== src/fields/CMakeLists.txt ===
# source files
set(COIN_FIELDS_FILES
	SoField.cpp
	SoFieldContainer.cpp
	SoFieldData.cpp
	SoMFBitMask.cpp
	SoMFBool.cpp
	SoMFColor.cpp
	SoMFColorRGBA.cpp
	SoMFDouble.cpp
	SoMFEngine.cpp
	SoMFEnum.cpp
	SoMFFloat.cpp
	SoMFInt32.cpp
	SoMFMatrix.cpp
	SoMFName.cpp
	SoMFNode.cpp
	SoMFPath.cpp
	SoMFPlane.cpp
	SoMFRotation.cpp
	SoMFShort.cpp
	SoMFString.cpp
	SoMFTime.cpp
	SoMFUInt32.cpp
	SoMFUShort.cpp
	SoMFVec2b.cpp
	SoMFVec2s.cpp
	SoMFVec2i32.cpp
	SoMFVec2f.cpp
	SoMFVec2d.cpp
	SoMFVec3b.cpp
	SoMFVec3s.cpp
	SoMFVec3i32.cpp
	SoMFVec3f.cpp
	SoMFVec3d.cpp
	SoMFVec4b.cpp
	SoMFVec4ub.cpp
	SoMFVec4s.cpp
	SoMFVec4us.cpp
	SoMFVec4i32.cpp
	SoMFVec4ui32.cpp
	SoMFVec4f.cpp
	SoMFVec4d.cpp
	SoMField.cpp
	SoSFBitMask.cpp
	SoSFBool.cpp
	SoSFBox2s.cpp
	SoSFBox2i32.cpp
	SoSFBox2f.cpp
	SoSFBox2d.cpp
	SoSFBox3s.cpp
	SoSFBox3i32.cpp
	SoSFBox3f.cpp
	SoSFBox3d.cpp
	SoSFColor.cpp
	SoSFColorRGBA.cpp
	SoSFDouble.cpp
	SoSFEngine.cpp
	SoSFEnum.cpp
	SoSFFloat.cpp
	SoSFImage.cpp
	SoSFImage3.cpp
	SoSFInt32.cpp
	SoSFMatrix.cpp
	SoSFName.cpp
	SoSFNode.cpp
	SoSFPath.cpp
	SoSFPlane.cpp
	SoSFRotation.cpp
	SoSFShort.cpp
	SoSFString.cpp
	SoSFTime.cpp
	SoSFTrigger.cpp
	SoSFUInt32.cpp
	SoSFUShort.cpp
	SoSFVec2b.cpp
	SoSFVec2s.cpp
	SoSFVec2i32.cpp
	SoSFVec2f.cpp
	SoSFVec2d.cpp
	SoSFVec3b.cpp
	SoSFVec3s.cpp
	SoSFVec3i32.cpp
	SoSFVec3f.cpp
	SoSFVec3d.cpp
	SoSFVec4b.cpp
	SoSFVec4ub.cpp
	SoSFVec4s.cpp
	SoSFVec4us.cpp
	SoSFVec4i32.cpp
	SoSFVec4ui32.cpp
	SoSFVec4f.cpp
	SoSFVec4d.cpp
	SoSField.cpp
	SoGlobalField.cpp
	shared.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_FIELDS_INTERNAL_FILES
	SoGlobalField.h
	SoGlobalField.cpp
	shared.h
	shared.cpp
	SoSubFieldP.h
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_FIELDS_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} fields/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(fields OBJECT ${COIN_FIELDS_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_FIELDS_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/fields/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_FIELDS_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/fields/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== src/fonts/CMakeLists.txt ===
# source files
set(COIN_FONTS_FILES
	fontlib_wrapper.cpp
	win32.cpp
	freetype.cpp
	coretext.cpp
	fontspec.cpp
	glyph.cpp
	glyph2d.cpp
	glyph3d.cpp
	default3dfont.cpp
	default2dfont.cpp
	common.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_FONTS_INTERNAL_FILES
	fontlib_wrapper.h
	fontlib_wrapper.cpp
	win32.h
	win32.cpp
	freetype.h
	freetype.cpp
	coretext.h
	coretext.cpp
	fontspec.h
	fontspec.cpp
	glyph.h
	glyph.cpp
	glyph2d.h
	glyph2d.cpp
	glyph3d.h
	glyph3d.cpp
	defaultfonts.h
	default3dfont.cpp
	default2dfont.cpp
	common.h
	common.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_FONTS_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} fonts/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(fonts OBJECT ${COIN_FONTS_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_FONTS_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/fonts/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_FONTS_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/fonts/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== src/profiler/CMakeLists.txt ===
# source files
set(COIN_PROFILER_FILES
	SoProfiler.cpp
	SoProfilerElement.cpp
	SoProfilerOverlayKit.cpp
	SoProfilerStats.cpp
	SoProfilingReportGenerator.cpp
	SoProfilerTopEngine.cpp
	SoScrollingGraphKit.cpp
	SoNodeVisualize.cpp
	SoProfilerTopKit.cpp
	SoProfilerVisualizeKit.cpp
	SbProfilingData.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_PROFILER_INTERNAL_FILES
	SoNodeProfiling.h
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_PROFILER_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} profiler/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(profiler OBJECT ${COIN_PROFILER_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_PROFILER_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/profiler/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_PROFILER_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/profiler/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

# SoProfilerP is not quite private, it is included from VRML nodes. The symbol is excluded from public API in doc/CMakeList.txt.
set(COIN_DOCUMENTATION_FILES
	${COIN_DOCUMENTATION_FILES}
	${CMAKE_SOURCE_DIR}/src/profiler/SoProfilerP.h
	CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
)

=== src/shaders/CMakeLists.txt ===
# source files
set(COIN_SHADERS_FILES
	SoFragmentShader.cpp
	SoGeometryShader.cpp
	SoGLARBShaderParameter.cpp
	SoGLARBShaderObject.cpp
	SoGLARBShaderProgram.cpp
	SoGLCgShaderObject.cpp
	SoGLCgShaderParameter.cpp
	SoGLCgShaderProgram.cpp
	SoGLSLShaderParameter.cpp
	SoGLSLShaderObject.cpp
	SoGLSLShaderProgram.cpp
	SoGLShaderObject.cpp
	SoGLShaderParameter.cpp
	SoGLShaderProgram.cpp
	SoGLShaderProgramElement.cpp
	SoShaderObject.cpp
	SoShaderParameter.cpp
	SoShaderProgram.cpp
	SoShader.cpp
	SoVertexShader.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_SHADERS_INTERNAL_FILES
	SoGLARBShaderParameter.h
	SoGLARBShaderParameter.cpp
	SoGLARBShaderObject.h
	SoGLARBShaderObject.cpp
	SoGLARBShaderProgram.h
	SoGLARBShaderProgram.cpp
	SoGLCgShaderObject.h
	SoGLCgShaderObject.cpp
	SoGLCgShaderParameter.h
	SoGLCgShaderParameter.cpp
	SoGLCgShaderProgram.h
	SoGLCgShaderProgram.cpp
	SoGLSLShaderParameter.h
	SoGLSLShaderParameter.cpp
	SoGLSLShaderObject.h
	SoGLSLShaderObject.cpp
	SoGLSLShaderProgram.h
	SoGLSLShaderProgram.cpp
	SoGLShaderObject.h
	SoGLShaderObject.cpp
	SoGLShaderParameter.h
	SoGLShaderParameter.cpp
	SoGLShaderProgram.h
	SoGLShaderProgram.cpp
	SoGLShaderProgramElement.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_SHADERS_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} shaders/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(shaders OBJECT ${COIN_SHADERS_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_SHADERS_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/shaders/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_SHADERS_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/shaders/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== src/shadows/CMakeLists.txt ===
# source files
set(COIN_SHADOWS_FILES
	SoShadowGroup.cpp
	SoShadowStyle.cpp
	SoShadowSpotLight.cpp
	SoShadowDirectionalLight.cpp
	SoShadowStyleElement.cpp
	SoShadowCulling.cpp
	SoGLShadowCullingElement.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_SHADOWS_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} shadows/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(shadows OBJECT ${COIN_SHADOWS_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_SHADOWS_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/shadows/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== debian/changelog ===
coin3 (4.0.2+ds-2) unstable; urgency=medium

  * Team upload
  * Unhijack package

 -- Bastian Germann <bage@debian.org>  Wed, 08 May 2024 21:34:34 +0000

coin3 (4.0.2+ds-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/64-bit-time-t-compat.patch: compatibility with 64-bit
    time_t.  Closes LP: #2058160.

 -- Steve Langasek <vorlon@debian.org>  Sun, 17 Mar 2024 21:56:00 +0000

coin3 (4.0.2+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062092

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 16:47:51 +0000

coin3 (4.0.2+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Drop patches, applied upstream: 01_convert_old_patches.patch,
      0004-Fix-GLX-glue-trying-to-use-NULL-display.patch,
      0005-Change-encoding.patch, 0006-Fix-encoding-issue.patch
  * Fix watchfile (Closes: #1057846) 

 -- Tobias Frost <tobi@debian.org>  Sat, 09 Dec 2023 16:57:42 +0100

coin3 (4.0.0+ds-5) unstable; urgency=medium

  * Team upload.
  * Avoid deprecation warning with CMake 3.27 (Closes: #1040725)
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Mon, 10 Jul 2023 00:27:22 +0200

coin3 (4.0.0+ds-4) unstable; urgency=medium

  Team upload.

  [ Leopold Palomo-Avellaneda ]
  * [914a7be] Drop unused files
  * [6541f99] Added examples
  * [e55eb53] Added pending files
  * [398d98d] Simplified rules and added examples
  * [fd91cb9] Added file specify not installed files
  * [2cab2b1] Added patch to fix encoding problem
  * [7f4e4b4] Bumb debhelper version. No changes
  * [a6cc7b9] Added patch to fix another encoding problem

  [ Gianfranco Costamagna ]
  * coin3: Fix autopkgtest regression due to new CMake warning (Closes: #1036843)

  [ Timo Röhling ]
  * Make xvfb-run invocation more robust

 -- Timo Röhling <roehling@debian.org>  Wed, 21 Jun 2023 21:26:21 +0200

=== debian/control ===
Source: coin3
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: graphics
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               cmake,
               doxygen,
               libexpat-dev,
               libx11-dev,
               libxext-dev,
               libxi-dev,
               libxmu-dev,
               libxpm-dev,
               libxt-dev,
               libboost-all-dev,
               freeglut3-dev,
	       libgl-dev,
	       libglvnd-dev,
	       libopengl-dev,
 	       libglew-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/coin3
Vcs-Git: https://salsa.debian.org/science-team/coin3.git
Homepage: https://github.com/coin3d

Package: libcoin80t64
Provides: ${t64:Provides}
X-Time64-Compat: libcoin80c
Breaks: libcoin80c (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libbz2-1.0,
          libfreetype6,
          libopenal0a,
          libsimage-dev,
          zlib1g
Pre-Depends: ${misc:Pre-Depends}
Replaces: libcoin80c, libcoin80v5
Description: high-level 3D graphics kit implementing the Open Inventor API
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.  Installing the suggested packages will enable
 extra features:
 .
     libsimage-dev enables loading of image files in SbImage
     libfreetype6 enables use of TrueType fonts
     libopenal0a   enables audio support
     zlib1g and libbz2 enable transparent read of compressed files

Package: libcoin-dev
Architecture: any
Section: libdevel
Depends: libcoin80t64 (= ${binary:Version}),
         libgl-dev,
	 libopengl-dev,
	 libglew-dev,
         libx11-dev,
         libxext-dev,
         libxi-dev,
         libxmu-dev,
         libxpm-dev,
         libxt-dev,
         ${misc:Depends}
Suggests: libcoin-doc (= ${binary:Version})
Replaces: libcoin80-dev
Breaks: libcoin80-dev
Conflicts: inventor-dev
Description: high-level 3D graphics devkit with Open Inventor and VRML97 support
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libcoin-dev (= ${binary:Version})
Replaces: libcoin80-doc
Breaks: libcoin80-doc
Description: high-level 3D graphics kit with Open Inventor and VRML97 support
 API documentation for the Coin library (the Open Inventor API) in
 HTML format.
 .
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin-runtime
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends}
Suggests: libcoin80t64
Replaces: libcoin80-runtime
Breaks: libcoin80-runtime
Description: high-level 3D graphics kit - external data files
 External data files used by the Coin library at run-time.  The
 dragger geometry files represent the defaults that are used if the
 files are not found.  This package is completely optional.

## coin3 4.0.3%2Bds

=== src/elements/GL/CMakeLists.txt ===
# source files
set(COIN_GLELEMENTS_FILES
	SoGLCacheContextElement.cpp
	SoGLClipPlaneElement.cpp
	SoGLColorIndexElement.cpp
	SoGLCoordinateElement.cpp
	SoGLDepthBufferElement.cpp
	SoGLDrawStyleElement.cpp
	SoGLEnvironmentElement.cpp
	SoGLLazyElement.cpp
	SoGLLightIdElement.cpp
	SoGLLinePatternElement.cpp
	SoGLLineWidthElement.cpp
	SoGLModelMatrixElement.cpp
	SoGLMultiTextureCoordinateElement.cpp
	SoGLMultiTextureEnabledElement.cpp
	SoGLMultiTextureMatrixElement.cpp
	SoGLMultiTextureImageElement.cpp
	SoGLNormalElement.cpp
	SoGLPointSizeElement.cpp
	SoGLPolygonOffsetElement.cpp
	SoGLProjectionMatrixElement.cpp
	SoGLRenderPassElement.cpp
	SoGLShapeHintsElement.cpp
	SoGLUpdateAreaElement.cpp
	SoGLVBOElement.cpp
	SoGLViewingMatrixElement.cpp
	SoGLViewportRegionElement.cpp
	SoGLDisplayList.cpp
	SoGLVertexAttributeElement.cpp
	SoResetMatrixElement.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_GLELEMENTS_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} elements/GL/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(glelements OBJECT ${COIN_GLELEMENTS_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_GLELEMENTS_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/elements/GL/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
set(COIN_DOCUMENTATION_FILES
	${COIN_DOCUMENTATION_FILES}
	${CMAKE_SOURCE_DIR}/src/elements/GL/SoResetMatrixElement.h
	CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
)
